/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSCrypto.h"

#include "Crypto.h"
#include <runtime/Error.h>
#include <wtf/GetPtr.h>

#if ENABLE(SUBTLE_CRYPTO)
#include "JSSubtleCrypto.h"
#include "SubtleCrypto.h"
#endif

using namespace JSC;

namespace WebCore {

/* Hash table */

static const HashTableValue JSCryptoTableValues[] =
{
#if ENABLE(SUBTLE_CRYPTO)
    { "webkitSubtle", DontDelete | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCryptoWebkitSubtle), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
#endif
    { 0, 0, NoIntrinsic, 0, 0 }
};

static const HashTable JSCryptoTable = { 2, 1, true, JSCryptoTableValues, 0 };
/* Hash table for prototype */

static const HashTableValue JSCryptoPrototypeTableValues[] =
{
    { "getRandomValues", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsCryptoPrototypeFunctionGetRandomValues), (intptr_t) (1) },
    { 0, 0, NoIntrinsic, 0, 0 }
};

static const HashTable JSCryptoPrototypeTable = { 2, 1, false, JSCryptoPrototypeTableValues, 0 };
const ClassInfo JSCryptoPrototype::s_info = { "CryptoPrototype", &Base::s_info, &JSCryptoPrototypeTable, 0, CREATE_METHOD_TABLE(JSCryptoPrototype) };

JSObject* JSCryptoPrototype::self(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMPrototype<JSCrypto>(vm, globalObject);
}

bool JSCryptoPrototype::getOwnPropertySlot(JSObject* object, ExecState* exec, PropertyName propertyName, PropertySlot& slot)
{
    JSCryptoPrototype* thisObject = jsCast<JSCryptoPrototype*>(object);
    return getStaticFunctionSlot<JSObject>(exec, JSCryptoPrototypeTable, thisObject, propertyName, slot);
}

const ClassInfo JSCrypto::s_info = { "Crypto", &Base::s_info, &JSCryptoTable, 0 , CREATE_METHOD_TABLE(JSCrypto) };

JSCrypto::JSCrypto(Structure* structure, JSDOMGlobalObject* globalObject, PassRefPtr<Crypto> impl)
    : JSDOMWrapper(structure, globalObject)
    , m_impl(impl.leakRef())
{
}

void JSCrypto::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(info()));
}

JSObject* JSCrypto::createPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return JSCryptoPrototype::create(vm, globalObject, JSCryptoPrototype::createStructure(vm, globalObject, globalObject->objectPrototype()));
}

void JSCrypto::destroy(JSC::JSCell* cell)
{
    JSCrypto* thisObject = static_cast<JSCrypto*>(cell);
    thisObject->JSCrypto::~JSCrypto();
}

JSCrypto::~JSCrypto()
{
    releaseImplIfNotNull();
}

bool JSCrypto::getOwnPropertySlot(JSObject* object, ExecState* exec, PropertyName propertyName, PropertySlot& slot)
{
    JSCrypto* thisObject = jsCast<JSCrypto*>(object);
    ASSERT_GC_OBJECT_INHERITS(thisObject, info());
    return getStaticValueSlot<JSCrypto, Base>(exec, JSCryptoTable, thisObject, propertyName, slot);
}

#if ENABLE(SUBTLE_CRYPTO)
EncodedJSValue jsCryptoWebkitSubtle(ExecState* exec, EncodedJSValue slotBase, EncodedJSValue thisValue, PropertyName)
{
    JSCrypto* castedThis = jsDynamicCast<JSCrypto*>(JSValue::decode(thisValue));
    UNUSED_PARAM(slotBase);
    if (!castedThis)
        return throwVMTypeError(exec);
    UNUSED_PARAM(exec);
    Crypto& impl = castedThis->impl();
    JSValue result = toJS(exec, castedThis->globalObject(), WTF::getPtr(impl.subtle()));
    return JSValue::encode(result);
}

#endif

EncodedJSValue JSC_HOST_CALL jsCryptoPrototypeFunctionGetRandomValues(ExecState* exec)
{
    JSValue thisValue = exec->hostThisValue();
    JSCrypto* castedThis = jsDynamicCast<JSCrypto*>(thisValue);
    if (!castedThis)
        return throwVMTypeError(exec);
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSCrypto::info());
    return JSValue::encode(castedThis->getRandomValues(exec));
}

static inline bool isObservable(JSCrypto* jsCrypto)
{
    if (jsCrypto->hasCustomProperties())
        return true;
    return false;
}

bool JSCryptoOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor)
{
    JSCrypto* jsCrypto = jsCast<JSCrypto*>(handle.get().asCell());
    if (!isObservable(jsCrypto))
        return false;
    Document* root = jsCrypto->impl().document();
    if (!root)
        return false;
    return visitor.containsOpaqueRoot(root);
}

void JSCryptoOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    JSCrypto* jsCrypto = jsCast<JSCrypto*>(handle.get().asCell());
    DOMWrapperWorld& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsCrypto->impl(), jsCrypto);
    jsCrypto->releaseImpl();
}

#if ENABLE(BINDING_INTEGRITY)
#if PLATFORM(WIN)
#pragma warning(disable: 4483)
extern "C" { extern void (*const __identifier("??_7Crypto@WebCore@@6B@")[])(); }
#else
extern "C" { extern void* _ZTVN7WebCore6CryptoE[]; }
#endif
#endif
JSC::JSValue toJS(JSC::ExecState* exec, JSDOMGlobalObject* globalObject, Crypto* impl)
{
    if (!impl)
        return jsNull();
    if (JSValue result = getExistingWrapper<JSCrypto>(exec, impl))
        return result;

#if ENABLE(BINDING_INTEGRITY)
    void* actualVTablePointer = *(reinterpret_cast<void**>(impl));
#if PLATFORM(WIN)
    void* expectedVTablePointer = reinterpret_cast<void*>(__identifier("??_7Crypto@WebCore@@6B@"));
#else
    void* expectedVTablePointer = &_ZTVN7WebCore6CryptoE[2];
#if COMPILER(CLANG)
    // If this fails Crypto does not have a vtable, so you need to add the
    // ImplementationLacksVTable attribute to the interface definition
    COMPILE_ASSERT(__is_polymorphic(Crypto), Crypto_is_not_polymorphic);
#endif
#endif
    // If you hit this assertion you either have a use after free bug, or
    // Crypto has subclasses. If Crypto has subclasses that get passed
    // to toJS() we currently require Crypto you to opt out of binding hardening
    // by adding the SkipVTableValidation attribute to the interface IDL definition
    RELEASE_ASSERT(actualVTablePointer == expectedVTablePointer);
#endif
    ReportMemoryCost<Crypto>::reportMemoryCost(exec, impl);
    return createNewWrapper<JSCrypto>(exec, globalObject, impl);
}

Crypto* toCrypto(JSC::JSValue value)
{
    return value.inherits(JSCrypto::info()) ? &jsCast<JSCrypto*>(value)->impl() : 0;
}

}
