/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(SQL_DATABASE)

#include "JSSQLResultSet.h"

#include "JSSQLResultSetRowList.h"
#include "SQLResultSet.h"
#include "SQLResultSetRowList.h"
#include <wtf/GetPtr.h>

using namespace JSC;

namespace WebCore {

/* Hash table */

static const HashTableValue JSSQLResultSetTableValues[] =
{
    { "rows", DontDelete | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsSQLResultSetRows), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { "insertId", DontDelete | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsSQLResultSetInsertId), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { "rowsAffected", DontDelete | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsSQLResultSetRowsAffected), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { 0, 0, NoIntrinsic, 0, 0 }
};

static const HashTable JSSQLResultSetTable = { 9, 7, true, JSSQLResultSetTableValues, 0 };
/* Hash table for prototype */

static const HashTableValue JSSQLResultSetPrototypeTableValues[] =
{
    { 0, 0, NoIntrinsic, 0, 0 }
};

static const HashTable JSSQLResultSetPrototypeTable = { 1, 0, false, JSSQLResultSetPrototypeTableValues, 0 };
static const HashTable& getJSSQLResultSetPrototypeTable(VM& vm)
{
    return getHashTableForGlobalData(vm, JSSQLResultSetPrototypeTable);
}

const ClassInfo JSSQLResultSetPrototype::s_info = { "SQLResultSetPrototype", &Base::s_info, 0, getJSSQLResultSetPrototypeTable, CREATE_METHOD_TABLE(JSSQLResultSetPrototype) };

JSObject* JSSQLResultSetPrototype::self(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMPrototype<JSSQLResultSet>(vm, globalObject);
}

static const HashTable& getJSSQLResultSetTable(VM& vm)
{
    return getHashTableForGlobalData(vm, JSSQLResultSetTable);
}

const ClassInfo JSSQLResultSet::s_info = { "SQLResultSet", &Base::s_info, 0, getJSSQLResultSetTable , CREATE_METHOD_TABLE(JSSQLResultSet) };

JSSQLResultSet::JSSQLResultSet(Structure* structure, JSDOMGlobalObject* globalObject, PassRefPtr<SQLResultSet> impl)
    : JSDOMWrapper(structure, globalObject)
    , m_impl(impl.leakRef())
{
}

void JSSQLResultSet::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(info()));
}

JSObject* JSSQLResultSet::createPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return JSSQLResultSetPrototype::create(vm, globalObject, JSSQLResultSetPrototype::createStructure(vm, globalObject, globalObject->objectPrototype()));
}

void JSSQLResultSet::destroy(JSC::JSCell* cell)
{
    JSSQLResultSet* thisObject = static_cast<JSSQLResultSet*>(cell);
    thisObject->JSSQLResultSet::~JSSQLResultSet();
}

JSSQLResultSet::~JSSQLResultSet()
{
    releaseImplIfNotNull();
}

bool JSSQLResultSet::getOwnPropertySlot(JSObject* object, ExecState* exec, PropertyName propertyName, PropertySlot& slot)
{
    JSSQLResultSet* thisObject = jsCast<JSSQLResultSet*>(object);
    ASSERT_GC_OBJECT_INHERITS(thisObject, info());
    return getStaticValueSlot<JSSQLResultSet, Base>(exec, getJSSQLResultSetTable(exec->vm()), thisObject, propertyName, slot);
}

EncodedJSValue jsSQLResultSetRows(ExecState* exec, EncodedJSValue slotBase, EncodedJSValue thisValue, PropertyName)
{
    JSSQLResultSet* castedThis = jsDynamicCast<JSSQLResultSet*>(JSValue::decode(thisValue));
    UNUSED_PARAM(slotBase);
    if (!castedThis)
        return throwVMTypeError(exec);
    UNUSED_PARAM(exec);
    SQLResultSet& impl = castedThis->impl();
    JSValue result = toJS(exec, castedThis->globalObject(), WTF::getPtr(impl.rows()));
    return JSValue::encode(result);
}


EncodedJSValue jsSQLResultSetInsertId(ExecState* exec, EncodedJSValue slotBase, EncodedJSValue thisValue, PropertyName)
{
    JSSQLResultSet* castedThis = jsDynamicCast<JSSQLResultSet*>(JSValue::decode(thisValue));
    UNUSED_PARAM(slotBase);
    if (!castedThis)
        return throwVMTypeError(exec);
    ExceptionCode ec = 0;
    SQLResultSet& impl = castedThis->impl();
    JSC::JSValue result = jsNumber(impl.insertId(ec));
    setDOMException(exec, ec);
    return JSValue::encode(result);
}


EncodedJSValue jsSQLResultSetRowsAffected(ExecState* exec, EncodedJSValue slotBase, EncodedJSValue thisValue, PropertyName)
{
    JSSQLResultSet* castedThis = jsDynamicCast<JSSQLResultSet*>(JSValue::decode(thisValue));
    UNUSED_PARAM(slotBase);
    if (!castedThis)
        return throwVMTypeError(exec);
    UNUSED_PARAM(exec);
    SQLResultSet& impl = castedThis->impl();
    JSValue result = jsNumber(impl.rowsAffected());
    return JSValue::encode(result);
}


bool JSSQLResultSetOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor)
{
    UNUSED_PARAM(handle);
    UNUSED_PARAM(visitor);
    return false;
}

void JSSQLResultSetOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    JSSQLResultSet* jsSQLResultSet = jsCast<JSSQLResultSet*>(handle.get().asCell());
    DOMWrapperWorld& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsSQLResultSet->impl(), jsSQLResultSet);
    jsSQLResultSet->releaseImpl();
}

JSC::JSValue toJS(JSC::ExecState* exec, JSDOMGlobalObject* globalObject, SQLResultSet* impl)
{
    if (!impl)
        return jsNull();
    if (JSValue result = getExistingWrapper<JSSQLResultSet>(exec, impl))
        return result;
#if COMPILER(CLANG)
    // If you hit this failure the interface definition has the ImplementationLacksVTable
    // attribute. You should remove that attribute. If the class has subclasses
    // that may be passed through this toJS() function you should use the SkipVTableValidation
    // attribute to SQLResultSet.
    COMPILE_ASSERT(!__is_polymorphic(SQLResultSet), SQLResultSet_is_polymorphic_but_idl_claims_not_to_be);
#endif
    ReportMemoryCost<SQLResultSet>::reportMemoryCost(exec, impl);
    return createNewWrapper<JSSQLResultSet>(exec, globalObject, impl);
}

SQLResultSet* toSQLResultSet(JSC::JSValue value)
{
    return value.inherits(JSSQLResultSet::info()) ? &jsCast<JSSQLResultSet*>(value)->impl() : 0;
}

}

#endif // ENABLE(SQL_DATABASE)
